// ************************ Get platform info *********************************
void GetPlatformInfo(int numPrn) {
cl_int numErr;
unsigned int i;
numErr = clGetPlatformIDs(numDev, plid, &num_platforms);
GetError("Num error clGetPlatformIDs", numErr);
if(numPrn !=0 ) {
  printf("\n----------- Platform info --------------------------------------\n");
  printf("\nnum_platforms = %i\n",num_platforms);
  printf("\numErrid\n");
  for(i=0; i < num_platforms; i++) {
    printf("%i\n", plid[i]); 
  }
}
numErr = clGetPlatformInfo(plid[num_platforms-1], CL_PLATFORM_NAME, numChar, strInfo, NULL);
GetError("Num error clGetPlatformInfo", numErr);
if(numPrn!=0) {
  printf("Name platform = %s\t\tRead byte = %i\n", strInfo, NULL);
  numErr = clGetPlatformInfo(plid[num_platforms-1], CL_PLATFORM_PROFILE, numChar, strInfo, NULL);
  printf("Profile = %s\n", strInfo);
  numErr = clGetPlatformInfo(plid[num_platforms-1], CL_PLATFORM_VERSION, numChar, strInfo, NULL);
  printf("Vedsion = %s\n", strInfo);
  numErr = clGetPlatformInfo(plid[num_platforms-1], CL_PLATFORM_VENDOR, numChar, strInfo, NULL);
  printf("Vendor = %s\n", strInfo);
  numErr = clGetPlatformInfo(NULL, CL_PLATFORM_EXTENSIONS, numChar, strInfo, NULL);
  printf("\nExtension = %s\n", strInfo);
}  
} //end fun

// ************************** Get device info *********************************
void GetDeviceInfo(int numPrn) {
cl_int numErr;
unsigned int i;
size_t nb;
printf("\n-------------- Device Info --------------------------------------\n\n");
numErr = clGetDeviceIDs(plid[num_platforms-1], devType, numDev, devices, num_devices);
GetError("Number error clGetDeviceIDs", numErr);
if(numPrn != 0) {
  printf("devices\t\tnum_devices\n");
  for(i=0; i < num_platforms; i++) {
    printf("%i\t\t%i\n", devices[i], num_devices[i]); 
  }
}  
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_NAME, numChar, strInfo, &nb);
GetError("Number error clGetDeviceInfo CL_DEVICE_NAME", numErr);
//if(numPrn != 0) 
printf("\nType Device\t%s\n", strInfo);
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_MAX_COMPUTE_UNITS, sizeof(unsigned int), &max_cu, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_MAX_COMPUTE_UNITS", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_MAX_COMPUTE_UNIT\t\t%i\n", max_cu);
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS, sizeof(unsigned int), &max_wi_dim, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_MAX_WORK_ITEM_DIMENTIONS\t%i\n", max_wi_dim);
ndim = (size_t*)malloc(max_wi_dim);
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_MAX_WORK_ITEM_SIZES,  max_wi_dim*sizeof(size_t), ndim, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_MAX_WORK_ITEM_SIZES", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_MAX_WORK_ITEM_SIZES\t\t");
if(numPrn != 0) { 
  for(i=0; i < max_wi_dim; i++) {
    printf("%li\t", ndim[i], ndim[i]);
  }
}
printf("\n");
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_MAX_WORK_GROUP_SIZE, sizeof(size_t), &max_wg_size, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_MAX_WORK_GROUP_SIZE", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_MAX_WORK_GROUP_SIZE\t\t%i\n", max_wg_size);
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_MAX_MEM_ALLOC_SIZE, sizeof(unsigned long long), 
                         &max_dev_mem, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_MAX_MEM_ALLOC_SIZE", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_MAX_MEM_ALLOC_SIZE\t\t%I64i\t%I64i Mb\n",  max_dev_mem, max_dev_mem/(1024*1024));
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_GLOBAL_MEM_SIZE, sizeof(unsigned long long), 
                         &max_dev_glmem, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_GLOBAL_MEM_SIZE", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_GLOBAL_MEM_SIZE\t\t%I64i\t%I64i Mb\n",  max_dev_glmem, max_dev_glmem/(1024*1024));
numErr = clGetDeviceInfo(devices[num_platforms-1], CL_DEVICE_LOCAL_MEM_SIZE,  sizeof(unsigned long long), &max_dev_locmem, NULL);
GetError("Number error clGetDeviceInfo CL_DEVICE_LOCAL_MEM_SIZE", numErr);
if(numPrn != 0) 
  printf("\nCL_DEVICE_LOCAL_MEM__SIZE\t\t%I64i\t\t%I64i kb\n", max_dev_locmem, max_dev_locmem/1024);
} // end myocl::GetDeviceInfo()

